
exports.select_articles = async function(data, user_config=undefined)
{
		var lib_config = {}
		lib_config['article'] = {}
		lib_config['article']['table'] = "required"
		lib_config['fields'] = 'required'
		lib_config['display'] = {}
		lib_config['display']['type_page'] = "front"
		lib_config['display']['prefix_template'] = "full_view"

		if(!user_config['sort'])
		{
			lib_config['sort'] = {}
			lib_config['sort']['id'] = ">"
		}
		
		lib_config['page'] = {}
		lib_config['page']['url'] = ''
		lib_config['page']['alias'] = 'page'
		lib_config['page']['count'] = 3


		var lib_config = await ext('com-api-system').log.valid_config(lib_config, user_config)


		if(lib_config['valid'] == false)
		{
			return lib_config
		}


		var result = {}
		result['articles'] = undefined
		result['fields'] = undefined
		result['pagination'] = undefined
		
		var display_article_db = {}
		var db_config = {}
		db_config['table'] = lib_config['fields']
		db_config['alias'] = 'config'
		db_config['value'] = {}
		db_config['value']['id'] = '1'
		var display_config_article_db = await ext('com-api-database').sqlite.read(data,db_config)
	

		if(display_config_article_db != undefined)
		{
			display_config_article_db = display_config_article_db[0]
			display_config_article_db['config'] = JSON.parse(display_config_article_db['config'])
		}
		else
		{
			await ext('com-api-system').log.write(await ext('node-callsites')()[0], "no article in the table: "+lib_config['article'][0]+", selected article id: "+lib_config['article'][1])
			return undefined
		}			
		

		
		var select_fields = []
		for(var i in display_config_article_db['config']['fields_diplay'])
		{
			if(display_config_article_db['config']['fields_diplay'][i][lib_config['display']['type_page']])
			{
				select_fields.push(i)
			}
		}



		if(select_fields==undefined)
		{
			await ext('com-api-system').log.write(await ext('node-callsites')()[0],"There are no selected fields")
		}
		else
		{
			var db_config = {}
			db_config['table'] = 'com_system_field_list'
			db_config['alias'] = 'id`title`alias`type'
			db_config['value'] = {}
			db_config['value']['id'] = select_fields.join('`')
			result['fields'] = await ext('com-api-database').sqlite.read(data,db_config)
		}


		if(Object.keys(result['fields']).length!=0)
		{
			


			var db_config = {}
			db_config['table'] = lib_config['article']['table']
			db_config['alias'] = "id"
			db_config['sort'] = lib_config['sort']
			var select_articles = await ext('com-api-database').sqlite.read(data,db_config)

			var result_pagination = await this.pagination(data,select_articles,lib_config['page']['count'],lib_config['page']['url'],lib_config['page']['alias'], 5)
			

			result['pagination'] = result_pagination['pagination']


			var select_alias = []
			for(var i in result['fields'])
			{
				select_alias.push(result['fields'][i]['alias'])
			}
			
			var db_config = {}
			db_config['table'] = lib_config['article']['table']
			db_config['alias'] = select_alias.join('`')+"`display"

			if(lib_config['article']['value_like'])
			{
				db_config['value_like'] = lib_config['article']['value_like']
			}

			db_config['value'] = {}
			db_config['value']['id'] = result_pagination['items'].join('`')

			db_config['sort'] = lib_config['sort']



			var select_articles = await ext('com-api-database').sqlite.read(data,db_config)

			if(select_articles!=undefined)
			{
				result['articles'] = select_articles

				for(var i in result['articles'])
				{
					result['articles'][i]['display'] = JSON.parse(result['articles'][i]['display'])
					result['articles'][i]['display']['fields'] = result['articles'][i]['display']['fields'][lib_config['display']['prefix_template']]
				}
			}
		}


	

		return result
	}




exports.view_article = async function(data, user_config=undefined)
{	
		

		var result = {}
		result['sub_articles'] = ""

		var lib_config = {}
		lib_config['article'] = 'required'
		lib_config['fields'] = 'required'
		lib_config['sub_articles'] = {}
		lib_config['sub_articles']['table'] = 'com_system_article_list'
		lib_config['sub_articles']['url'] = "" 
		lib_config['url'] = ""
		lib_config['display'] = {}
		lib_config['display']['type_page'] = "front"

		
		var lib_config = await ext('com-api-system').log.valid_config(lib_config, user_config)

	


		if(lib_config['valid'] == false)
		{
			return lib_config
		}

		
		if(lib_config['sub_articles'] && lib_config['sub_articles']['table'])
		{
	
			var config = {}
			config['fields'] = lib_config['sub_articles']['fields']
			config['article'] = {}
			config['article']['table'] = lib_config['sub_articles']['table']
			config['article']['value_like'] = {}
			config['article']['value_like']['category'] = '%"0"%'
			config['display'] = {}
			config['display']['type_page'] = "front"
			config['display']['prefix_template'] = "introe_view"
			var r = await ext('com-api-system').article.select_articles(data, config)
			console.log(r)


			/*
			var db_config = {}
			db_config['table'] = 'com_system_field_list'
			db_config['alias'] = 'id`title`alias`type'
			db_config['value'] = {}
			db_config['value']['id'] = lib_config['article']['display']['sub_article']['sort']['field']
			var select_sort_field = await ext('com-api-database').sqlite.read(data,db_config)

			
			var db_config = {}
			db_config['table'] = 'com_system_article_list'
			db_config['alias'] = "id"
			db_config['value_like'] = {}
			db_config['value_like'][lib_config['sub_articles']['category']] = '%"'+lib_config['article']['id']+'"%';
			db_config['value_like']['type_article'] = lib_config['sub_articles']['type'];
			db_config['sort'] = {}
			db_config['sort'][select_sort_field[0]['alias']] = lib_config['article']['display']['sub_article']['sort']['type']
			var sub_articles = await ext('com-api-database').sqlite.read(data,db_config)

			if(sub_articles!=undefined)
			{
				for(var i in sub_articles)
				{
					var config = {}
					config['fields'] = lib_config['sub_articles']['fields']
					config['article'] = lib_config['sub_articles']['table']+'`'+sub_articles[i]['id']
					config['display'] = {}
					config['display']['type_page'] = "front"
					config['display']['prefix_template'] = "intro_view"
					var r = await ext('com-api-system').article.select_article(data, config)



					var config = {}
					config['fields'] = r['fields']
					config['article'] = r['article']
					config['display'] = {}
					config['display']['type_page'] = "front"
					config['display']['prefix_template'] = "intro_view"
					config['url']= lib_config['sub_articles']['url']
					
					var r = await ext('com-api-system').article.view_article(data, config)
				
					r['component'] = "blog"
					r['function'] = "article"

					result['sub_articles'] += await ext('com-api-system').load.component(data, r)

				}
			}
			*/
			
			
		}
		
		var config = {}
		config['fields'] = lib_config['fields']
		config['article'] = lib_config['article']
		config['url'] = lib_config['url']

		result['fields'] = await ext('com-api-system').field.views(data,config)
		

		if(lib_config['display']['prefix_template']!=undefined)
		{
			result['prefix_template'] = lib_config['display']['prefix_template']
		}

		result['template'] = config['article']['display'][lib_config['display']['prefix_template']]['template']
		


		return result
	
		

	}


exports.pagination = async function(data,items,count,url,alias_page,limit_center_count=false){
	
		if(data.user.get_data!=undefined)
		{
			var get_data_string = ""
			for(var g_d in data.user.get_data)
			{
				if(g_d!=alias_page)
				{
					if(get_data_string != "")
					{
						get_data_string+="&"+g_d+"="+data.user.get_data[g_d]
					}
					else
					{
						get_data_string+="?"+g_d+"="+data.user.get_data[g_d]
					}
				}
			}
			if(get_data_string!="")
			{
				url+=get_data_string
				url+='&'+alias_page+'='
			}
			else
			{
				url+='?'+alias_page+'='
			}
			
		}
		else
		{
			url+='?'+alias_page+'='
		}

		if(data.user.get_data!=undefined && data.user.get_data[alias_page]!=undefined)
		{
			var num_page = data.user.get_data[alias_page]
		}
		else
		{
			var num_page = 1
		}
		
	

		num_page = parseInt(num_page)
	   var result = {}
	   result['items'] = []
	   result['pagination'] = '<ul class="pagination">'

	   var start_i = count*num_page-count
	   var end_i = count*num_page
	   var all_pages = items.length/count
	   all_pages = Math.ceil(all_pages)

	   for(var i in items)
	   {
	   		if(i<=end_i-1 && i>=start_i)
	   		{
	   			result['items'].push(items[i][Object.keys(items[i])[0]])
	   		}
	   }


	   var tag_page = []

	   if(num_page!=1)
	   {
	   		var back_num_page = num_page-1
	   		tag_page.push('<li class="previous"><a href="'+url+back_num_page+'"></a></li>')
	   }
	   else
	   {
	   		tag_page.push('<li class="previous disabled"><a ></a></li>')
	   }

	   for(var i=1; i<=all_pages; i++)
	   {
	   		if(num_page>limit_center_count)
	   		{

		   		if(limit_center_count!=undefined && i<=num_page-limit_center_count)
		   		{
		   			continue
		   		}
	   		
		   		if(limit_center_count!=undefined && i>=num_page+limit_center_count+1)
		   		{
		   			continue
		   		}
	   		}
	   		else
	   		{
	   			if(limit_center_count!=undefined && i>=limit_center_count+limit_center_count+1)
		   		{
		   			continue
		   		}
	   		}
	   		
	   		if(num_page == i)
	   		{
	   			tag_page.push('<li class="item active"><a>'+i+'</a></li>')
	   		}
	   		else
	   		{	
	   			tag_page.push('<li class="item"><a href="'+url+i+'">'+i+'</a></li>')
	   		}
	   }


	   for(var i in tag_page)
	   {
		   	

	   		result['pagination'] =  result['pagination']+tag_page[i]

	   }

	   


	   if(num_page!=all_pages)
	   {
	   		var next_num_page = num_page+1
	   		result['pagination'] += '<li class="next"><a href="'+url+next_num_page+'"></a></li>'
	   }
	   else
	   {
	   		result['pagination'] += '<li class="next disabled"><a"></a></li>'
	   }

	   result['pagination'] = result['pagination']+'</ul>'


	  	

	   if(result['items'].length == 0)
	   {
	   		return "0";
	   }

	   return result;
	   
	}
